# The LearningOnline Network with CAPA
# caparesponse definition
#
# $Id: caparesponse.pm,v 1.75 2002/12/02 17:06:09 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::caparesponse;
use strict;
use capa;

BEGIN {
  &Apache::lonxml::register('Apache::caparesponse',('caparesponse','numericalresponse','stringresponse','formularesponse'));
}

sub start_caparesponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my $id = &Apache::response::start_response($parstack,$safeeval);
  return '';
}

sub end_caparesponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result = '';
  if ( $target eq 'grade' ) {
    if ( defined $ENV{'form.submitted'}) {
      $safeeval->share_from('capa',['&caparesponse_capa_check_answer']);
      my $response = $ENV{'form.HWVAL'.$Apache::inputtags::response['-1']};
      if ( $response =~ /[^\s]/) {
	my $id = $Apache::inputtags::response['-1'];
	my $previous= &Apache::response::check_for_previous($response,$id,$response);
	if ( $previous ) { 
	  $result = 'PREVIOUSLY_USED';
	} else {
	  $Apache::lonhomework::results{"resource.$Apache::inputtags::part.$id.submission"}=$response;
	  &Apache::lonxml::debug("submitted a $response<br>\n");
	  &Apache::lonxml::debug($$parstack[$#$parstack] . "\n<br>");
	  my $expression="&caparesponse_check('".$response."','".
	    $$parstack[$#$parstack].
	      ';my $tol="'.$Apache::inputtags::params{'tol'}.'"'.
		';my $sig="'.$Apache::inputtags::params{'sig'}.'"'.
		  "');";
	  $result = &Apache::run::run($expression,$safeeval);
	  my ($ad) = split /:/ , $result;
	  $Apache::lonhomework::results{"resource.$Apache::inputtags::part.$id.awarddetail"}=$ad;
	  &Apache::lonxml::debug("$expression");
	  &Apache::lonxml::debug("\n<br>result:$result:$Apache::lonxml::curdepth<br>\n");
	}
      }
    }
  } elsif ($target eq 'web') {
    #$result .= "The correct answer is ".&Apache::run::run("{$$parstack['-1'];".'return $answer}',$safeeval)."\n";
  }
  #Apache::lonxml::debug("\n<br>\nreal end caparesponse<br>\n");
  &Apache::response::end_response;
  return '';
}

sub start_numericalresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my $id = &Apache::response::start_response($parstack,$safeeval);
  my $result;
  if ($target eq 'edit') {
    $result.=&Apache::edit::tag_start($target,$token);
    $result.=&Apache::edit::text_arg('Answer:','answer',$token);
    if ($token->[1] eq 'numericalresponse') {
      $result.=&Apache::edit::text_arg('Unit:','unit',$token,5);
      $result.=&Apache::edit::text_arg('Format:','format',$token,4);
    } elsif ($token->[1] eq 'stringresponse') {
      $result.=&Apache::edit::select_arg('Type:','type',
		 [['cs','Case Sensitive'],['ci','Case Insensitive'],
		  ['mc','Case Insensitive, Any Order']],$token);
    } elsif ($token->[1] eq 'formularesponse') {
      $result.=&Apache::edit::text_arg('Sample Points:','samples',$token,40);
    }
    $result.=&Apache::edit::end_row().&Apache::edit::start_spanning_row();
  } elsif ($target eq 'modified') {
    my $constructtag;
    if ($token->[1] eq 'numericalresponse') {
      $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						'answer','unit','format');
    } elsif ($token->[1] eq 'stringresponse') {
      $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						'answer','type');
    } elsif ($token->[1] eq 'formularesponse') {
      $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						'answer','samples');
    }
    if ($constructtag) {
      $result = &Apache::edit::rebuild_tag($token);
      $result.=&Apache::edit::handle_insert();
    }
  } elsif ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('numericalresponse');
  } elsif ($target eq 'answer' || $target eq 'grade') {
      &Apache::response::reset_params();
  }
  return $result;
}

sub end_numericalresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result = '';
  if (!$Apache::lonxml::default_homework_loaded) {
      &Apache::lonxml::default_homework_load($safeeval);
  }
  if ( $target eq 'grade' ) {
    if ( defined $ENV{'form.submitted'}) {
      &Apache::response::setup_params($$tagstack[-1]);
      $safeeval->share_from('capa',['&caparesponse_capa_check_answer']);
      my $partid = $Apache::inputtags::part;
      my $id = $Apache::inputtags::response['-1'];
      my $response = $ENV{'form.HWVAL'.$id};
      if ( $response =~ /[^\s]/) {
	my %previous = &Apache::response::check_for_previous($response,$partid,$id);
	$Apache::lonhomework::results{"resource.$partid.$id.submission"}=$response;
	&Apache::lonxml::debug("submitted a $response<br>\n");
	&Apache::lonxml::debug($$parstack[$#$parstack] . "\n<br>");
	$response =~ s/\\/\\\\/g;
	$response =~ s/\'/\\\'/g;
	&Apache::lonxml::debug("current $response");
	my $expression="&caparesponse_check_list('".$response."','".
	  $$parstack[$#$parstack];
	foreach my $key (keys(%Apache::inputtags::params)) {
	  $expression.= ';my $'. #'
	    $key.'="'.$Apache::inputtags::params{$key}.'"';
	}
	if ($$tagstack[-1] eq 'formularesponse') {
	  $expression.=';my $type="fml";';
	} elsif ($$tagstack[-1] eq 'numericalresponse') {
	  $expression.=';my $type="float";';
	}
	$expression.="');";
	$result = &Apache::run::run($expression,$safeeval);
	my ($awards) = split /:/ , $result;
	my ($ad) = &Apache::inputtags::finalizeawards(split /,/ , $awards);
	&Apache::response::handle_previous(\%previous,$ad);
	$Apache::lonhomework::results{"resource.$partid.$id.awarddetail"}=$ad;
	&Apache::lonxml::debug("$expression");
	&Apache::lonxml::debug("\n<br>result:$result:$Apache::lonxml::curdepth<br>\n");
	$result='';
      }
    }
  } elsif ($target eq 'web' || $target eq 'tex') {
      my $award = $Apache::lonhomework::history{"resource.$Apache::inputtags::part.solved"};
      my $status = $Apache::inputtags::status['-1'];
      if ($award =~ /^correct/ || $status eq "SHOW_ANSWER" ) {
	my (@answers)=&Apache::lonxml::get_param_var('answer',$parstack,
						     $safeeval);
	my (@formats)=&Apache::lonxml::get_param_var('format',$parstack,
						     $safeeval);
	my $unit=&Apache::lonxml::get_param_var('unit',$parstack,$safeeval);
	
	if ($target eq 'web') {
	  $result="<br />The correct answer is ";
        } elsif ($target eq 'tex') {
	  #$result='\vskip 0 mm The correct answer is \\texttt{';
        }
	for (my $i=0; $i <= $#answers; $i++) {
	   my $answer=$answers[$i];
	   my $format;
	   if ($#formats > 0) {
	     $format=$formats[$i];
	   } else {
	     $format=$formats[0];
	   }
	   my $formatted;
	   if ((defined($format)) && ($format ne '')) {
	     &Apache::lonxml::debug("formatting with :$format: answer :$answer:");
	     $formatted=sprintf('%.'.$format,$answer).',';
	   } else {
	     &Apache::lonxml::debug("no format answer :$answer:");
	     $formatted="$answer,";
	   }
	   if ($target eq 'tex') {
	       $formatted='';
	       #$formatted=&Apache::lonxml::latex_special_symbols($formatted);
	   }
	   $result.=$formatted;
       }
	   chop $result;
	   if ($target eq 'web') {
	     $result.=" $unit.<br />";
	   } elsif ($target eq 'tex') {
	     #$result.=&Apache::lonxml::latex_special_symbols($unit);
	     #$result.="}. \\vskip 0 mm ";
	   }
       }
      if ($Apache::lonhomework::type eq 'exam') {
      	my (@answers)=&Apache::lonxml::get_param_var('answer',$parstack,$safeeval);
	my (@formats)=&Apache::lonxml::get_param_var('format',$parstack,$safeeval);
	my $unit=&Apache::lonxml::get_param_var('unit',$parstack,$safeeval);
	my $number_of_bubbles = 8; #default values for number of bubbles
	my @bubbles_values = (); 
	my @factors = (1.13,1.17,1.25,1.33,1.45); #default values of factors
	my @powers = (1.0,2.0,3.0,4.0,5.0,6.0,7.0,8.0); #default values for powers
	my $factors_number = 5; #default values for number of factors
	my $powers_number = 8; #default values for number of powers
	my $symb;
	if ($ENV{'form.symb'}=~/___\d+___/) {$symb=$ENV{'form.symb'};} else {$symb=$ENV{'request.symb'};}
	my $randomseed = srand(&Apache::lonnet::rndseed($symb,$ENV{'request.course.id'},
                                                              $ENV{'user.domain'},$ENV{'user.name'}));
	my $ind=1+int(rand()*($factors_number-1));
	my $factor = $factors[$ind];
	$ind=1+int(rand()*($powers_number-1));
	my $power = $powers[$ind];
	for ($ind=0;$ind<$number_of_bubbles;$ind++) {
	    $bubbles_values[$ind] = $answers[0]*$factor**($power-$powers[$powers_number-$ind-1]);
	}	    
	my @alphabet = ('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P',
			'Q','R','S','T','U','V','W','X','Y','Z');
        if ($target eq 'web') {
	    my $id=$Apache::inputtags::response[-1];
	    $result.= '<table border="1"><tr>';
	    for ($ind=0;$ind<$number_of_bubbles;$ind++) {
		my $ans;
		if ($formats[0] ne '') {
		    $ans = sprintf('%.'.$formats[0],$bubbles_values[$ind]);
		} else {
		    my $badans = $bubbles_values[$ind];
		    my $format = ''; 
                    #What is the number? (integer,decimal,floating point)
                    if ($badans=~/^(\d*\.?\d*)(E|e)(\d*)$/) {
			$format = 'e'.$2;
		    } elsif ($badans=~/^(\d*)\.(\d*)$/) {
			$format = '4f';
		    } elsif ($badans=~/^(\d*)$/) {
			$format = 'd';
		    }
		    $ans = sprintf('%.'.$format,$bubbles_values[$ind]);
		}
		    $result.='<td><input type="radio" name="HWVAL'.$id.'" value="'.$ans.'"><b>'.$alphabet[$ind].'</b>: '.$ans.'</td>';
	    }
	    $result.='</tr></table>';
	} elsif ($target eq 'tex') {
	    my $max_val = 0;
	    if ($formats[0]=~m/^(\d+)E([^\d]*)(\d*)$/) {
		$max_val=$1+$2+4;
	    } else {
		$max_val=4;
	    }
	    $max_val = int(0.9*$ENV{'form.textwidth'}/(($max_val+6)*2));
            my $celllength = 0.9*$ENV{'form.textwidth'}/$max_val-10;
	    my @table_range = ();
	    my $number_of_tables = int($number_of_bubbles/$max_val);
	    for (my $i=0;$i<$number_of_tables;$i++) {push @table_range,$max_val;}
	    if ($number_of_bubbles % $max_val != 0) {
		$number_of_tables++;
		push @table_range,($number_of_bubbles % $max_val);
	    }
	    my $j=0;
	    my $cou=0;
	    $result.='\vskip -1 mm \noindent \begin{enumerate}\item[\textbf{'.$Apache::lonxml::counter.'}.]';
	    for (my $i=0;$i<$number_of_tables;$i++) {
		$result.='\vskip -1 mm \noindent \begin{tabular}{';
		for ($ind=0;$ind<$table_range[$j];$ind++) {
		    $result.='lp{'.$celllength.' mm}';
		}
		$result.='}';
		for ($ind=$cou;$ind<$cou+$table_range[$j];$ind++) {
		    my $ans;
		    if ($formats[0] ne '') {
			$ans = sprintf('%.'.$formats[0],$bubbles_values[$ind]);
			if ($ans =~ m/([0-9\.\-\+]+)E([0-9\-\+]+)/ ) {
			    my $number = $1;
			    my $power = $2;
			    $power=~s/^\+//;
			    $power=~s/^(-?)0+(\d+)//;
			    $ans=$number.'$\times 10^{'.$1.$2.'}$'; #'stupidemacs
			} 
		    } else {
			my $badans = $bubbles_values[$ind];
			my $format = ''; 
			#What is the number? (integer,decimal,floating point)
			if ($badans=~/^(\d*\.?\d*)(E|e)(\d*)$/) {
			    $format = 'e'.$2;
			} elsif ($badans=~/^(\d*)\.(\d*)$/) {
			    $format = '4f';
			} elsif ($badans=~/^(\d*)$/) {
			    $format = 'd';
			}
			$ans = sprintf('%.'.$format,$bubbles_values[$ind]);			
			if ($ans =~ m/([0-9\.\-\+]+)E([0-9\-\+]+)/ ) {
			    my $number = $1;
			    my $power = $2;
			    $power=~s/^\+//;
			    $power=~s/^(-?)0+(\d+)//;
			    $ans=$number.'$\times 10^{'.$1.$2.'}$'; #'stupidemacs
			} 
		    }
		    $result.='\hskip -3 mm {\small \textbf{'.$alphabet[$ind].'}}$\bigcirc$\hskip -2 mm & {\small '.$ans.'} ';
		    if ($ind != $cou+$table_range[$j]-1) {$result.=' & ';}
		}
		$cou += $table_range[$j];
		$j++;
		$result.='\\\\\end{tabular}\vskip 0 mm ';    
	    }
	    $result.='\end{enumerate}';
	    &Apache::lonxml::increment_counter();
	}
    }
  } elsif ($target eq 'edit') {
    $result.='</td></tr>'.&Apache::edit::end_table;
  } elsif ($target eq 'answer' || $target eq 'analyze') {

      my $part_id="$Apache::inputtags::part.$Apache::inputtags::response[-1]";
      if ($target eq 'analyze') {
	  push (@{ $Apache::lonhomework::analyze{"parts"} },$part_id);
	  $Apache::lonhomework::analyze{"$part_id.type"} = $$tagstack[-1];
      }
      &Apache::response::setup_params($$tagstack[-1]);
      my (@answers)=&Apache::lonxml::get_param_var('answer',$parstack,$safeeval);
      my (@formats)=&Apache::lonxml::get_param_var('format',$parstack,$safeeval);
      my $unit=&Apache::lonxml::get_param_var('unit',$parstack,$safeeval);
      my $type=&Apache::lonxml::get_param('type',$parstack,$safeeval);

      if ($target eq 'answer') {
	  $result.=&Apache::response::answer_header($$tagstack[-1]);
      }
      for(my $i=0;$i<=$#answers;$i++) {
	  my $ans=$answers[$i];
	  my $fmt;
	  if (@formats) {
	      if ($#formats) {
		  $fmt=$formats[$i];
	      } else {
		  $fmt=$formats[0];
	      }
	  }
	  my ($high,$low);
	  if ($Apache::inputtags::params{'tol'}) {
	      ($high,$low)=&get_tolrange($ans,$Apache::inputtags::params{'tol'});
	  }
	  my ($sighigh,$siglow);
	  if ($Apache::inputtags::params{'sig'}) {
	      ($sighigh,$siglow)=&get_sigrange($Apache::inputtags::params{'sig'});
	  }
	  if ($fmt) {
	      $ans = sprintf('%.'.$fmt,$ans);
	      if ($high) {
		  $high = sprintf('%.'.$fmt,$high); $low = sprintf('%.'.$fmt,$low);
	      }
	  }
	  if ($target eq 'answer') {
	      if ($high) { $ans.=' ['.$low.','.$high.']'; }
	      if ($sighigh) { $ans.= " Sig <i>$siglow - $sighigh</i>"; }
	      $result.=&Apache::response::answer_part($$tagstack[-1],$ans);
	  } elsif ($target eq 'analyze') {
	      push (@{ $Apache::lonhomework::analyze{"$part_id.answer"} },
		    $ans);
	      if ($high) {
		  push (@{ $Apache::lonhomework::analyze{"$part_id.ans_high"} }, $high);
		  push (@{ $Apache::lonhomework::analyze{"$part_id.ans_low"} }, $low);
	      }
	  }
      }
      if ($unit) {
	  if ($target eq 'answer') {
	      $result.=&Apache::response::answer_part($$tagstack[-1],
						      "Unit: <b>$unit</b>");
	  } elsif ($target eq 'analyze') {
	      push (@{ $Apache::lonhomework::analyze{"$part_id.unit"} },
		    $unit);
	  }
      }
      if ($type || $token->[1] eq 'stringresponse') {
	  my $string='Case Insensitive';
	  if ($type eq 'mc') {
	      $string='Multiple Choice';
	  } elsif ($type eq 'cs') {
	      $string='Case Sensitive';
	  } elsif ($type eq 'ci') {
	      $string='Case Insensitive';
	  } elsif ($type eq 'fml') {
	      $string='Formula';
	  }
	  if ($target eq 'answer') {
	      $result.=&Apache::response::answer_part($$tagstack[-1],
						      '<b>'.$string.'</b>');
	  } elsif ($target eq 'analyze') {
	      push (@{ $Apache::lonhomework::analyze{"$part_id.type"} },
		    $type);
	  }
      }
      if ($$tagstack[-1] eq 'formularesponse' && $target eq 'answer') {
	  my $samples=&Apache::lonxml::get_param('samples',$parstack,$safeeval);
	  $result.=&Apache::response::answer_part($$tagstack[-1],$samples);
      }
      if ($target eq 'answer') {
	  $result.=&Apache::response::answer_footer($$tagstack[-1]);
      }
  }
  &Apache::response::end_response;
  return $result;
}

sub get_tolrange {
  my ($ans,$tol)=@_;
  my ($high,$low);
  if ($tol =~ /%$/) {
    chop($tol);
    my $change=$ans*($tol/100.0);
    $high=$ans+$change;
    $low=$ans-$change;
  } else {
    $high=$ans+$tol;
    $low=$ans-$tol;
  }
  return ($high,$low);
}

sub get_sigrange {
  my ($sig)=@_;
  &Apache::lonxml::debug("Got a sig of :$sig:");
  my $sig_lbound;
  my $sig_ubound;
  if ($sig eq '') {
    $sig_lbound = 0; #SIG_LB_DEFAULT
    $sig_ubound =15; #SIG_UB_DEFAULT
  } else {
    ($sig_lbound,$sig_ubound) = split(/,/,$sig);
    if (!$sig_lbound) {
      $sig_lbound = 0; #SIG_LB_DEFAULT
      $sig_ubound =15; #SIG_UB_DEFAULT
    }
    if (!$sig_ubound) { $sig_ubound=$sig_lbound; }
  }
  return ($sig_ubound,$sig_lbound);
}

sub start_stringresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result;
  if ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('stringresponse');
  } else {
    $result.=&start_numericalresponse(@_);
  }
  return $result;
}

sub end_stringresponse {
  return end_numericalresponse(@_);
}

sub start_formularesponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result;
  if ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('formularesponse');
  } else {
    $result.=&start_numericalresponse(@_);
  }
  return $result;
}

sub end_formularesponse {
  return end_numericalresponse(@_);
}

1;
__END__
 
