# The LearningOnline Network with CAPA
# Wrapper for external and binary files as standalone resources
#
# $Id: lonwrapper.pm,v 1.6 2003/01/20 17:03:25 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Edit Handler for RAT Maps
# (TeX Content Handler
#
# 05/29/00,05/30 Gerd Kortemeyer)
# 7/1,6/30 Gerd Kortemeyer)
#
# 7/5 Gerd Kortemeyer

package Apache::lonwrapper;

use strict;
use Apache::Constants qw(:common);
use Apache::lonnet();
use Apache::lonxml();

# ================================================================ Main Handler

sub handler {
  my $r=shift;
  $r->content_type('text/html');
  $r->send_http_header;

  return OK if $r->header_only;

  my $url=$r->uri;
  $url=~s/^\/adm\/wrapper//;
  $url=~s/^\/ext\//http\:\/\//;
  if ($url=~/^\/uploaded\//) {
      $url=&Apache::lonnet::tokenwrapper($url);
  }
  my $events='onLoad="'.&Apache::lonxml::loadevents.
           '" onUnload="'.&Apache::lonxml::unloadevents.'"';
  my $script=&Apache::lonxml::registerurl(1,undef);
  $r->print(<<ENDDOCUMENT);
<html>
<head>
$script
</head>
<frameset rows="1,*" border=0 $events>
<frame src="/adm/rat/empty.html">
<frame src="$url">
</frameset>
</html>
ENDDOCUMENT
  return OK;
}

1;
__END__







